<?php
//
// Auteur : Didier, JLuc, www.ouhpla.net
// 
// Licence GPL 
//
//
// Transforme les brèves de tout le site en articles,
// les met dans une même rubrique
// et leur attribue optionnellement un même auteur


// Reprise de la fonction forum_insert() du plugin forum

function forum_insert($force_statut = NULL) {
	# en reponse a
	$id_forum = intval(_request('id_forum'))>0?intval(_request('id_forum')):0;

	# objet
	$id_objet = intval(_request('id_objet'));
	$objet = _request('objet');

	# temporaire vieux code
// Ajout de la prise en compte de l'evenement , Didier
	if (!$id_objet OR !$objet) {
		foreach (array('article', 'breve', 'rubrique', 'syndic', 'message','ticket', 'evenement')
		as $ob) {
			if ($id = intval(_request('id_'.$ob))) {
				$objet = $ob;
				$id_objet = $id;
			}
		}
	}

	spip_log("insertion de forum sur $objet $id_objet (+$id_forum)", 'forum');

	$reqret = rawurldecode(_request('retour_forum'));
	$retour = ($reqret !== '!')
		? $reqret
		: forum_insert_nopost($id_forum, $objet, $id_objet);

	$c = array('statut'=>'off');
	$c['objet'] = $objet;
	$c['id_objet'] = $id_objet;

	foreach (array(
		'titre', 'texte', 'nom_site', 'url_site'
	) as $champ)
		$c[$champ] = _request($champ);

	$c['auteur'] = sinon($GLOBALS['visiteur_session']['nom'],
		$GLOBALS['visiteur_session']['session_nom']);
	$c['email_auteur'] = sinon($GLOBALS['visiteur_session']['email'],
		$GLOBALS['visiteur_session']['session_email']);

	$c = pipeline('pre_edition',array(
		'args'=>array(
				'table' => 'spip_forum',
				'id_objet' => $id_forum,
				'action'=>'instituer'
		),
		'data'=>forum_insert_statut($c, $retour, $force_statut)
	));

	$id_reponse = forum_insert_base($c, $id_forum, $objet, $id_objet, $c['statut'], $retour);

	if (!$id_reponse) {
		spip_log("Echec insertion $retour", 'forum');
		return array($retour,0); // echec
	}
	else
		spip_log("forum insere' $id_reponse", 'forum');

	// En cas de retour sur (par exemple) {#SELF}, on ajoute quand
	// meme #forum12 a la fin de l'url, sauf si un #ancre est explicite
	if ($reqret !== '!')
		return array(
			strpos($retour, '#') ? $retour : $retour.'#forum'.$id_reponse,
			$id_reponse
		);

	// le retour par defaut envoie sur le thread, ce qui permet
	// de traiter elegamment le cas des forums moderes a priori.
	// Cela assure aussi qu'on retrouve son message dans le thread
	// dans le cas des forums moderes a posteriori, ce qui n'est
	// pas plus mal.
	if (function_exists('generer_url_forum')) {
		$url = generer_url_forum($id_reponse);
	} else {
		$thread = sql_fetsel('id_thread', 'spip_forum', 'id_forum='.$id_reponse);
spip_log('id_thread='.$thread['id_thread'], 'forum');
		$url = generer_url_entite($thread['id_thread'], 'forum');
	}

	return array($url, $id_reponse);
}

?>
